DEFINT A-Z  ' Make all variables integer (for more free memory and speed)
'$DYNAMIC   ' used for more free memory (needed for sprites)

' Declaring of subs
DECLARE SUB Endtext ()
DECLARE SUB GetBLASTER (DMA%, Baseport%, IRQ%)
DECLARE SUB Playsound (number%)
DECLARE SUB Midistop ()
DECLARE SUB MIDIload (Filename$, MIDISegment%, MIDIOffset%)
DECLARE SUB MIDIplay (MIDISegment%, MIDIOffset%)
DECLARE SUB MasterVolume (Right%, Left%, Getvol%)
DECLARE SUB WriteDSP (Byte%)
DECLARE SUB SpeakerState (OnOff%)
DECLARE SUB DMAplay (Segment&, Offset&, Length&, Freq&)
DECLARE SUB Menu ()
DECLARE SUB DrawBOX (dsegment%, doffset%, x%, y%, x1%, y1%)
DECLARE SUB Palette.Load (Filename AS STRING)
DECLARE SUB Palette.set (nColor%, Red%, Green%, Blue%)
DECLARE SUB Playgame ()
DECLARE SUB BlastLoad (Buffer() AS INTEGER, Filename AS STRING)
DECLARE SUB BlastGet (dsegment%, doffset%, ssegment%, soffset%, x1%, y1%, x2%, y2%)
DECLARE SUB BlastPUT (dsegment%, doffset%, ssegment%, soffset%, xpos%, ypos%, icol%)
DECLARE SUB BlastPset (Segment%, Offset%, xpos%, ypos%, col%)
DECLARE SUB BlastCopy (fsegment%, foffset%, tsegment%, toffset%)
DECLARE SUB BlastScroll (fsegment%, foffset%, tsegment%, toffset%, xoffset%, yoffset%)
DECLARE SUB BlastCLS (Segment%, Offset%, col%)
DECLARE SUB BLASTprint (Segment%, Offset%, xpos%, ypos%, text$, col%)
DECLARE SUB BlastLine (dsegment%, doffset%, x1%, y1%, x2%, y2%, colr%)
DECLARE SUB BlastInit ()
DECLARE SUB drawObjects ()
DECLARE SUB moveObjects ()
DECLARE SUB NewSubmarine (number%)
DECLARE SUB Init ()
DECLARE SUB drawSubmarines ()
DECLARE SUB moveSubmarines ()
DECLARE SUB newSubmarines ()
DECLARE SUB moveship ()
DECLARE SUB moveBombs ()
DECLARE SUB drawBombs ()
DECLARE SUB drawShip ()
DECLARE SUB newBomb ()
DECLARE SUB Delay (seconds AS DOUBLE)

' Declaring of Functions
DECLARE FUNCTION MIDIBytes& (Filename$)
DECLARE FUNCTION DMAinit% ()
DECLARE FUNCTION ReadDSP% ()
DECLARE FUNCTION DSPVersion! ()
DECLARE FUNCTION DMADone% ()
DECLARE FUNCTION ResetDSP% ()
DECLARE FUNCTION randomNumber (minValue, maxValue)
DECLARE FUNCTION getKey ()
DECLARE FUNCTION inside (insideX, insideY, insideX1, insideY1, x, y)
DECLARE FUNCTION BlastPoint (Segment, Offset, xpos, ypos)

' Game constants
CONST ScreensizeX = 320
CONST ScreensizeY = 200
CONST spacebar = 32
CONST ArrowUp = 20480
CONST ArrowDown = 18432
CONST Arrowright = 19712
CONST Arrowleft = 19200
CONST Enter = 13

CONST true = -1
CONST False = 0

CONST LakePictureFile = "picture2.pic"
CONST SpriteFile = "picture1.pic"
CONST Palettefile = "palette.pal"
CONST TitlePicture = "title.pic"

CLEAR

' Types
TYPE Bombtype

   Depth AS INTEGER
   Position AS INTEGER
   Smashing AS INTEGER
   frame AS INTEGER
END TYPE

TYPE subMarinetype

   Depth AS INTEGER
   Position AS INTEGER
   Exploded AS INTEGER
   Speed AS INTEGER
   frame AS INTEGER
END TYPE

TYPE Shiptype

   Position AS INTEGER
   Smash AS INTEGER
   frame AS INTEGER
END TYPE

TYPE DMAtype

   Baseport AS INTEGER
   LenPort AS INTEGER
   Channel AS INTEGER
END TYPE

TYPE MIDItype
  
   Playtime AS SINGLE
   Errorcode AS INTEGER
   LOADED AS INTEGER
   INTERRUPT AS INTEGER
   SENSITIVE AS INTEGER
   SOUNDDISABLED AS INTEGER
END TYPE

TYPE Gametype

   maxBombs AS INTEGER
   maxSubmarines AS INTEGER
   Releasetime AS INTEGER
   SpeedBombs AS INTEGER
   SpeedShip AS INTEGER
   Time AS SINGLE
END TYPE

ON ERROR GOTO errorhandling

DIM SHARED game AS Gametype
DIM SHARED Bomb(10) AS Bombtype
DIM SHARED Ship AS Shiptype
DIM SHARED Submarine(10) AS subMarinetype
DIM SHARED DMA AS DMAtype
DIM SHARED ActiveBombs AS INTEGER
DIM SHARED ActiveSubmarines AS INTEGER
DIM SHARED keyPresswait AS SINGLE
DIM SHARED code1%(14), code2%(21), code3%(91), code4%(76), code6%(17), code7%(25), code8%(118), code9%(14)
DIM SHARED SBsound(1) AS STRING * 5408
DIM SHARED SBsound1(1) AS STRING * 15306
DIM SHARED SBsound2(1) AS STRING * 3698
DIM SHARED SBsound3(1) AS STRING * 9224
DIM SHARED soundon AS INTEGER
DIM SHARED MIDI AS MIDItype
DIM SHARED MIDIfile1(MIDIBytes&("song1.mid") \ 2)
DIM SHARED MIDIfile2(MIDIBytes&("song2.mid") \ 2)
DIM SHARED Errorcode AS INTEGER

' Graphics arrays (+sprites)
DIM SHARED ScreenBuffer(31999)
DIM SHARED Shipsprite(5600)
DIM SHARED Textbuffer(3400)
DIM SHARED Bombsprite(15 * 10 + 15)
DIM SHARED BombSprite1(20)
DIM SHARED Submarinesprite(3000)
DIM SHARED Submarinesprite1(600 * 10)
DIM SHARED Submarinesprite2(2000)
DIM SHARED Submarinesprite3(600 * 10)
DIM SHARED Explosionsprite(2000)
DIM SHARED GranateSprite(200)

PRINT "Initializing SUBMARINES.... Please wait"
BlastInit   ' Initialize the BLAST graphics library
IF DMAinit THEN soundon = true      ' Check the blaster environment is set
Init        ' Initialize the game


DO
   Menu
   Playgame    ' Lets play the game!
LOOP

errorhandling:    ' When a error ocurred. This error handling is not very
                  ' complex, i was just too lazy to make a good one.

IF Errorcode = 1 THEN RESUME NEXT   ' very easy; when a error is occured,
                                      just try the next command.

SCREEN 0: WIDTH 80                  ' if that isn't possible:
                                    ' the end of the game ;-)
CLS
COLOR 15, 1
PRINT STRING$(80, " ")
LOCATE 1
PRINT "Game aborted. Errorcode: "; ERR
COLOR 7, 0
PRINT "For more information, send email to dan_boon@dds.nl"
END

' thats all folks! ;-)

REM $STATIC
SUB BlastCLS (Segment%, Offset%, col%)
  '
  ' Clear the screen!
  '
  DEF SEG = VARSEG(code6%(0))
  '
  CALL ABSOLUTE(BYVAL Segment%, BYVAL Offset%, BYVAL col%, VARPTR(code6%(0)))
  '
  DEF SEG
  '
END SUB

SUB BlastCopy (fsegment%, foffset%, tsegment%, toffset%)
  '
  ' No error checking is done for this routine, so be careful when
  ' you set the from and to segements and offsets - you could crash
  ' your machine...
  '
  ' I have noticed on slower machines running QuickBASIC that the following
  ' line slows the code down. Comment this line out if you notice it. For
  ' some reason QBASIC is unaffected. This line is only used to cut down on
  ' screen shearing at the time of the copy, and isn't needed unless you need
  ' the most solid display anyhow...
  '
  IF tsegment% = &HA000 THEN WAIT &H3DA, 8            ' Wait for vertical retrace
  '
  ' Copy!
  '
  DEF SEG = VARSEG(code1%(0))
  '
  CALL ABSOLUTE(BYVAL fsegment%, BYVAL foffset%, BYVAL tsegment%, BYVAL toffset%, VARPTR(code1%(0)))
  '
  DEF SEG
  '
END SUB

SUB BlastGet (dsegment%, doffset%, ssegment%, soffset%, x1%, y1%, x2%, y2%)
  '
  ' No error checking is done for X and Y coordinates, nor for any segments
  ' and offsets into memory. Therefore, use care when setting them so you
  ' don't crash your machine.
  '
  DEF SEG = VARSEG(code4%(0))
  '
  CALL ABSOLUTE(BYVAL dsegment%, BYVAL doffset%, BYVAL ssegment%, BYVAL soffset%, BYVAL x1%, BYVAL y1%, BYVAL x2%, BYVAL y2%, VARPTR(code4%(0)))
  '
  DEF SEG
  '
END SUB

SUB BlastInit
  '
  ' BlastCopy! (BLSTCOPY.ASM)
  '
  code$ = "1E5589E58B460E8ED88B760C8B460A8EC08B7E08B9007DF3A55D1FCA0800"
  '
  DEF SEG = VARSEG(code1%(0))
  '
  FOR I% = 0 TO 29
    d% = VAL("&h" + MID$(code$, I% * 2 + 1, 2))
    POKE VARPTR(code1%(0)) + I%, d%
  NEXT I%
  '
  DEF SEG
  '
  ' BlastPset! (BLSTPSET.ASM)
  '
  code$ = "1E5589E58B46108ED88B760AB106D3E689F3B102D3E601DE8B5E0C01DE8B5E0E01DE8A460888045D1FCA0A00"
  '
  DEF SEG = VARSEG(code2%(0))
  '
  FOR I% = 0 TO 43
    d% = VAL("&h" + MID$(code$, I% * 2 + 1, 2))
    POKE VARPTR(code2%(0)) + I%, d%
  NEXT I%
  '
  DEF SEG
  '
  ' BlastPut! (BLASTPUT.ASM)
  '
  code$ = "1E5589E58B460C508B460A508B46108ED88B760E8B04B103D3E8508B5EFE"
  code$ = code$ + "01C3895EFE8B4402508B5EFC01C3895EFC83C60489760E89E58B46188ED8"
  code$ = code$ + "8B76168A04468976163A4610743DBB0000395E147C35395E127C30BB3F01"
  code$ = code$ + "395E147F28BBC700395E127F208B5E1C8EDB8B7612B106D3E689F3B102"
  code$ = code$ + "D3E601DE8B5E1401DE8B5E1A01DE88048B4614408946148B460639461475"
  code$ = code$ + "A18B46142B46028946148B4612408946128B46043946127589585858585D"
  code$ = code$ + "1FCA0E00"
  '
  DEF SEG = VARSEG(code3%(0))
  '
  FOR I% = 0 TO 182
    d% = VAL("&h" + MID$(code$, I% * 2 + 1, 2))
    POKE VARPTR(code3%(0)) + I%, d%
  NEXT I%
  '
  DEF SEG
  '
  ' BlastGet! (BLASTGET.ASM)
  '
  code$ = "1E5589E58B460A508B4608508B460A2B460E40508B46082B460C40508B46128ED8"
  code$ = code$ + "8B76108B46FABB0800F7E3890446468B46F88904464689761089E58B5E"
  code$ = code$ + "1E8EDB8B7614B106D3E689F3B102D3E601DE8B5E1601DE8B5E1C01DE8A"
  code$ = code$ + "048B5E1A8EDB8B76188804468976188B4616408946168B460639461676"
  code$ = code$ + "C38B46162B46028946168B4614408946148B460439461476AB58585858"
  code$ = code$ + "5D1FCA1000"
  '
  DEF SEG = VARSEG(code4%(0))
  '
  FOR I% = 0 TO 153
    d% = VAL("&h" + MID$(code$, I% * 2 + 1, 2))
    POKE VARPTR(code4%(0)) + I%, d%
  NEXT I%
  '
  DEF SEG
  '
  ' BlastCLS! (BLASTCLS.ASM)
  '
  code$ = "1E5589E58B460C8ED88B760A8B460888C4B900FA890483C60283E90275F65D1FCA0600"
  '
  DEF SEG = VARSEG(code6%(0))
  '
  FOR I% = 0 TO 34
    d% = VAL("&h" + MID$(code$, I% * 2 + 1, 2))
    POKE VARPTR(code6%(0)) + I%, d%
  NEXT I%
  '
  DEF SEG
  '
  ' BlastPoint! (BLASTPNT.ASM)
  '
  code$ = "1E5589E58B46128ED88B760CB106D3E689F3B102D3E601DE8B5E0C01DE8B5E100"
  code$ = code$ + "1DE8A1C8B460A8ED88B7608881C5D1FCA0C00"
  '
  DEF SEG = VARSEG(code7%(0))
  '
  FOR I% = 0 TO 50
    d% = VAL("&h" + MID$(code$, I% * 2 + 1, 2))
    POKE VARPTR(code7%(0)) + I%, d%
  NEXT I%
  '
  DEF SEG
  '
  ' BlastLine! (BLSTLINE.ASM)
  '
  code$ = "1E5589E58B460C2B4610508B460A2B460E50B8010050B840015089E58B46188B5E1439"
  code$ = code$ + "D87E168B4602BBFFFFF7E38946028B4606BBFFFFF7E38946068B46168B5E"
  code$ = code$ + "1239D87E168B4600BBFFFFF7E38946008B4604BBFFFFF7E38946048B46"
  code$ = code$ + "1C8ED88B7616B106D3E689F3B102D3E601DE8B5E1801DE8B5E1A01DE"
  code$ = code$ + "8B46068B5E0439D87E2FBB000089C13D00007F07B9FFFFF7E189C18A46"
  code$ = code$ + "108804037602035E043B5E067C060376002B5E064983F9007DE4EB32B8"
  code$ = code$ + "000089D983FB007F0C89D8B9FFFFF7E189C1B800008A5E10881C037600"
  code$ = code$ + "0346063B46047C060376022B46044983F9007DE4585858585D1FCA0E00"
  '
  DEF SEG = VARSEG(code8%(0))
  '
  FOR I% = 0 TO 237
    d% = VAL("&h" + MID$(code$, I% * 2 + 1, 2))
    POKE VARPTR(code8%(0)) + I%, d%
  NEXT I%
  '
  DEF SEG
  '
  ' BlastScroll! (BLSTSCRL.ASM)
  '
  code$ = "1E5589E58B46108ED88B760E8B460C8EC08B7E0A8B4E08F3A45D1FCA0A00"
  '
  DEF SEG = VARSEG(code9%(0))
  '
  FOR I% = 0 TO 29
    d% = VAL("&h" + MID$(code$, I% * 2 + 1, 2))
    POKE VARPTR(code9%(0)) + I%, d%
  NEXT I%
  '
  DEF SEG
  '
END SUB

SUB BlastLine (dsegment%, doffset%, x1%, y1%, x2%, y2%, colr%)
  '
  ' This is a simple routine which uses the traditional
  ' Bresenham Algorithm to draw a line between two points.
  '
  ' No error checking is performed for endpoints in this routine,
  ' so be careful not to let the ends fall out of bounds, since
  ' doing so may cause your machine to crash...
  '
  DEF SEG = VARSEG(code8%(0))
  '
  CALL ABSOLUTE(BYVAL dsegment%, BYVAL doffset%, BYVAL x1%, BYVAL y1%, BYVAL x2%, BYVAL y2%, BYVAL colr%, VARPTR(code8%(0)))
  '
  DEF SEG
  '
END SUB

SUB BlastLoad (Buffer() AS INTEGER, Filename AS STRING)

   DEF SEG = VARSEG(Buffer(0))
   BLOAD Filename, VARPTR(Buffer(0))
END SUB

FUNCTION BlastPoint% (Segment%, Offset%, xpos%, ypos%)
  '
  ' No error checking is done for X and Y coordinates, nor for any segments
  ' and offsets into memory. Therefore, use care when setting them so you
  ' don't crash your machine.
  '
  ' Get the pixel!
  '
  col% = 0
  '
  DEF SEG = VARSEG(code7%(0))
  '
  CALL ABSOLUTE(BYVAL Segment%, BYVAL Offset%, BYVAL xpos%, BYVAL ypos%, BYVAL VARSEG(col%), BYVAL VARPTR(col%), VARPTR(code7%(0)))
  '
  DEF SEG
  '
  BlastPoint% = col%
  '
END FUNCTION

SUB BLASTprint (Segment%, Offset%, xpos%, ypos%, text$, col%)
  '
  ' CGA Character Set (8 x 8)
  '
  xx% = xpos% - 1
  yy% = ypos%
  '
  FOR chr% = 1 TO LEN(text$)
    xx% = xx% + 8
    ptr% = 8 * ASC(MID$(text$, chr%, 1)) + &HE
    FOR L% = 0 TO 7
      DEF SEG = &HFFA6: BitPattern% = PEEK(ptr% + L%): DEF SEG
      IF BitPattern% AND 1 THEN CALL BlastPset(Segment%, Offset%, xx%, yy% + L%, col%)
      IF BitPattern% AND 2 THEN CALL BlastPset(Segment%, Offset%, xx% - 1, yy% + L%, col%)
      IF BitPattern% AND 4 THEN CALL BlastPset(Segment%, Offset%, xx% - 2, yy% + L%, col%)
      IF BitPattern% AND 8 THEN CALL BlastPset(Segment%, Offset%, xx% - 3, yy% + L%, col%)
      IF BitPattern% AND 16 THEN CALL BlastPset(Segment%, Offset%, xx% - 4, yy% + L%, col%)
      IF BitPattern% AND 32 THEN CALL BlastPset(Segment%, Offset%, xx% - 5, yy% + L%, col%)
      IF BitPattern% AND 64 THEN CALL BlastPset(Segment%, Offset%, xx% - 6, yy% + L%, col%)
      IF BitPattern% AND 128 THEN CALL BlastPset(Segment%, Offset%, xx% - 7, yy% + L%, col%)
    NEXT
  NEXT
  '
  DEF SEG
  '
END SUB

SUB BlastPset (Segment%, Offset%, xpos%, ypos%, col%)
  '
  ' No error checking is done for X and Y coordinates, nor for any segments
  ' and offsets into memory. Therefore, use care when setting them so you
  ' don't crash your machine.
  '
  ' Plot the pixel!
  '
  DEF SEG = VARSEG(code2%(0))
  '
  CALL ABSOLUTE(BYVAL Segment%, BYVAL Offset%, BYVAL xpos%, BYVAL ypos%, BYVAL col%, VARPTR(code2%(0)))
  '
  DEF SEG
  '
END SUB

SUB BlastPUT (dsegment%, doffset%, ssegment%, soffset%, xpos%, ypos%, icol%)
  '
  ' No error checking is done for X and Y coordinates, nor for any segments
  ' and offsets into memory. Therefore, use care when setting them so you
  ' don't crash your machine.
  '
  DEF SEG = VARSEG(code3%(0))
  '
  CALL ABSOLUTE(BYVAL dsegment%, BYVAL doffset%, BYVAL ssegment%, BYVAL soffset%, BYVAL xpos%, BYVAL ypos%, BYVAL icol%, VARPTR(code3%(0)))
  '
  DEF SEG
  '
END SUB

SUB BlastScroll (fsegment%, foffset%, tsegment%, toffset%, xoffset%, yoffset%)
  '
  ' Scroll the screen!
  '
  NumBytes% = &HFA00 ' 64000 Bytes
  '
  OffsetBytes% = (ABS(yoffset%) * 320)
  NumBytes% = NumBytes% - OffsetBytes%
  '
  IF yoffset% >= 0 THEN
    foffset% = foffset% + OffsetBytes%
  ELSE
    toffset% = toffset% + OffsetBytes%
  END IF
  '
  OffsetBytes% = ABS(xoffset%)
  NumBytes% = NumBytes% - OffsetBytes%
  '
  IF xoffset% >= 0 THEN
    foffset% = foffset% + OffsetBytes%
  ELSE
    toffset% = toffset% + OffsetBytes%
  END IF
  '
  DEF SEG = VARSEG(code9%(0))
  '
  CALL ABSOLUTE(BYVAL fsegment%, BYVAL foffset%, BYVAL tsegment%, BYVAL toffset%, BYVAL NumBytes%, VARPTR(code9%(0)))
  '
  DEF SEG
  '
END SUB

SUB Delay (seconds AS DOUBLE)
'
'  Delays the pc X seconds
'
DIM dummy AS SINGLE
dummy = TIMER

DO WHILE dummy + seconds > TIMER

LOOP

END SUB

DEFSNG A-Z
FUNCTION DMADone%
countlo% = INP(DMA.LenPort%)
counthi% = INP(DMA.LenPort%)
count& = CLNG(counthi% * 256&) + CLNG(countlo%)
'if you have problems with L&-8, then use L&-1
IF count& > L& - 1 THEN
        ack% = INP(Baseport% + &HE)
        OUT &H20, &H20 'acknowledge SB interrupt 1-15
        DMADone% = -1
END IF
END FUNCTION

DEFINT A-Z
FUNCTION DMAinit


IF LEN(ENVIRON$("BLASTER")) = 0 THEN PRINT "BLASTER environment variable not set.": EXIT FUNCTION
FOR Length% = 1 TO LEN(ENVIRON$("BLASTER"))
   SELECT CASE MID$(ENVIRON$("BLASTER"), Length%, 1)
      CASE "A"
        DMA.Baseport = VAL("&H" + MID$(ENVIRON$("BLASTER"), Length% + 1, 3))
      CASE "I"
        DMA.LenPort% = VAL(MID$(ENVIRON$("BLASTER"), Length% + 1, 1))
      CASE "D"
        DMA.Channel = VAL(MID$(ENVIRON$("BLASTER"), Length% + 1, 1))
   END SELECT
NEXT

IF ResetDSP% THEN 'resets DSP (returns true if sucessful)

   DMAinit = true
ELSE

   DMAinit = False
END IF

SpeakerState 1 'turn the speaker on
MasterVolume 15, 15, 0
END FUNCTION

SUB DMAplay (Segment&, Offset&, Length&, Freq&)

IF NOT soundon THEN EXIT SUB

' Transfers and plays the contents of the buffer.
Length& = Length& - 1
Page% = 0
MemLoc& = Segment& * 16 + Offset&
SELECT CASE DMA.Channel%
    CASE 0
       PgPort% = &H87
       AddPort% = &H0
       DMAlenPort% = &H1
       ModeReg% = &H48
    CASE 1
       PgPort% = &H83
       AddPort% = &H2
       DMAlenPort% = &H3
       ModeReg% = &H49
    CASE 2
       PgPort% = &H81
       AddPort% = &H4
       DMAlenPort% = &H5
       ModeReg% = &H4A
    CASE 3
       PgPort% = &H82
       AddPort% = &H6
       DMAlenPort% = &H7
       ModeReg% = &H4B
    CASE ELSE
       'DMA channels 0-3 only are supported.
       EXIT SUB
END SELECT

OUT &HA, &H4 + DMA.Channel%
OUT &HC, &H0
OUT &HB, ModeReg%
OUT AddPort%, MemLoc& AND &HFF
OUT AddPort%, (MemLoc& AND &HFFFF&) \ &H100
IF (MemLoc& AND 65536) THEN Page% = Page% + 1
IF (MemLoc& AND 131072) THEN Page% = Page% + 2
IF (MemLoc& AND 262144) THEN Page% = Page% + 4
IF (MemLoc& AND 524288) THEN Page% = Page% + 8
OUT PgPort%, Page%
OUT DMAlenPort%, Length& AND &HFF
OUT DMAlenPort%, (Length& AND &HFFFF&) \ &H100
OUT &HA, DMA.Channel%

TimeConst% = 256 - 1000000 \ Freq&
WriteDSP &H40
WriteDSP TimeConst%
WriteDSP &H14
WriteDSP (Length& AND &HFF)
WriteDSP ((Length& AND &HFFFF&) \ &H100)

END SUB

SUB DrawBOX (dsegment, doffset, x, y, x1, y1)
'
' Draws a shadow-box on the screen.
'

BlastLine dsegment, doffset, x, y, x1, y, 255
BlastLine dsegment, doffset, x, y, x, y1, 255
BlastLine dsegment, doffset, x + 1, y + 1, x1 - 1, y + 1, 234
BlastLine dsegment, doffset, x + 1, y + 1, x + 1, y1 - 1, 234
BlastLine dsegment, doffset, x + 2, y + 2, x1 - 2, y + 2, 208
BlastLine dsegment, doffset, x + 2, y + 2, x + 2, y1 - 2, 208

BlastLine dsegment, doffset, x, y1, x1, y1, 208
BlastLine dsegment, doffset, x1, y, x1, y1, 208
BlastLine dsegment, doffset, x1 - 1, y + 1, x1 - 1, y1 - 1, 234
BlastLine dsegment, doffset, x + 1, y1 - 1, x1 - 1, y1 - 1, 234
BlastLine dsegment, doffset, x1 - 2, y + 2, x1 - 2, y1 - 2, 255
BlastLine dsegment, doffset, x + 2, y1 - 2, x1 - 2, y1 - 2, 255

FOR I = y + 3 TO y1 - 3
   BlastLine dsegment, doffset, x + 3, I, x1 - 3, I, 114
NEXT
END SUB

SUB drawObjects
'
' Draws the Objects (sprites) on the screen
'
  
   ' Make a copy of parts of the screen where the sprite will be putted
   FOR counter = 1 TO ActiveSubmarines

      CALL BlastGet(VARSEG(ScreenBuffer(0)), VARPTR(ScreenBuffer(0)), VARSEG(Submarinesprite1(0)), VARPTR(Submarinesprite1(600 * counter)), Submarine(counter).Position, Submarine(counter).Depth + 40, Submarine(counter).Position + 24, Submarine( _
counter).Depth + 60)
   NEXT
   CALL BlastGet(VARSEG(ScreenBuffer(0)), VARPTR(ScreenBuffer(0)), VARSEG(Shipsprite(0)), VARPTR(Shipsprite(5040)), Ship.Position, 26, Ship.Position + 39, 40)
   FOR counter = 1 TO ActiveBombs
  
      CALL BlastGet(VARSEG(ScreenBuffer(0)), VARPTR(ScreenBuffer(0)), VARSEG(Bombsprite(0)), VARPTR(Bombsprite(15 * counter + 15)), Bomb(counter).Position, Bomb(counter).Depth + 40, Bomb(counter).Position + 5, Bomb(counter).Depth + 43)
   NEXT
   CALL BlastGet(VARSEG(ScreenBuffer(0)), VARPTR(ScreenBuffer(0)), VARSEG(Textbuffer(0)), VARPTR(Textbuffer(2400)), 0, 190, 150, 200)

   ' ** DRAW BOMBS **
 
   FOR counter = 1 TO ActiveBombs
  
      IF Bomb(counter).Smashing = False THEN CALL BlastPUT(VARSEG(ScreenBuffer(0)), VARPTR(ScreenBuffer(0)), VARSEG(BombSprite1(0)), VARPTR(BombSprite1(15)), Bomb(counter).Position, Bomb(counter).Depth + 40, 255)
   NEXT

   ' ** DRAW SHIP **

   CALL BlastPUT(VARSEG(ScreenBuffer(0)), VARPTR(ScreenBuffer(0)), VARSEG(Shipsprite(0)), VARPTR(Shipsprite(560 * Ship.frame)), Ship.Position, 26, 255)

   IF Ship.Smash > 0 THEN

      CALL BlastPUT(VARSEG(ScreenBuffer(0)), VARPTR(ScreenBuffer(0)), VARSEG(Shipsprite(0)), VARPTR(Shipsprite(5040)), Ship.Position, 26, 255)
      CALL BlastPUT(VARSEG(ScreenBuffer(0)), VARPTR(ScreenBuffer(0)), VARSEG(Shipsprite(0)), VARPTR(Shipsprite(560 * (Ship.frame + 4))), Ship.Position, 26, 255)
      
      Ship.Smash = Ship.Smash - 1
   END IF
  
   ' ** DRAW SUBMARINES **

   FOR counter = 1 TO ActiveSubmarines
      
      IF Submarine(counter).Speed < 1 THEN
         IF Submarine(counter).Exploded = 0 THEN
            CALL BlastPUT(VARSEG(ScreenBuffer(0)), VARPTR(ScreenBuffer(0)), VARSEG(Submarinesprite2(0)), VARPTR(Submarinesprite2(480 * Submarine(counter).frame)), Submarine(counter).Position, Submarine(counter).Depth + 40, 255)
         ELSE
            CALL BlastPUT(VARSEG(ScreenBuffer(0)), VARPTR(ScreenBuffer(0)), VARSEG(Explosionsprite(0)), VARPTR(Explosionsprite(480 * Submarine(counter).frame)), Submarine(counter).Position, Submarine(counter).Depth + 40, 255)
         END IF
      ELSE
         IF Submarine(counter).Exploded = 0 THEN
            CALL BlastPUT(VARSEG(ScreenBuffer(0)), VARPTR(ScreenBuffer(0)), VARSEG(Submarinesprite(0)), VARPTR(Submarinesprite(480 * Submarine(counter).frame)), Submarine(counter).Position, Submarine(counter).Depth + 40, 255)
         ELSE
            CALL BlastPUT(VARSEG(ScreenBuffer(0)), VARPTR(ScreenBuffer(0)), VARSEG(Explosionsprite(0)), VARPTR(Explosionsprite(480 * Submarine(counter).frame)), Submarine(counter).Position, Submarine(counter).Depth + 40, 255)
         END IF
      END IF
   NEXT

   ' print time-left message
   BLASTprint VARSEG(ScreenBuffer(0)), VARPTR(ScreenBuffer(0)), 5, 190, "TIME LEFT:" + STR$(90 - INT(TIMER - game.Time)), 118
  
   'Put Buffer on screen
   CALL BlastCopy(VARSEG(ScreenBuffer(0)), VARPTR(ScreenBuffer(0)), &HA000, 0)

   ' ** Remove sprites from screen

   CALL BlastPUT(VARSEG(ScreenBuffer(0)), VARPTR(ScreenBuffer(0)), VARSEG(Textbuffer(0)), VARPTR(Textbuffer(2400)), 0, 190, 254)

   CALL BlastPUT(VARSEG(ScreenBuffer(0)), VARPTR(ScreenBuffer(0)), VARSEG(Shipsprite(0)), VARPTR(Shipsprite(5040)), Ship.Position, 26, 254)
   FOR counter = 1 TO ActiveBombs

      CALL BlastPUT(VARSEG(ScreenBuffer(0)), VARPTR(ScreenBuffer(0)), VARSEG(Bombsprite(0)), VARPTR(Bombsprite(15 * counter + 15)), Bomb(counter).Position, Bomb(counter).Depth + 40, 254)
   NEXT
   FOR counter = 1 TO ActiveSubmarines
      CALL BlastPUT(VARSEG(ScreenBuffer(0)), VARPTR(ScreenBuffer(0)), VARSEG(Submarinesprite1(0)), VARPTR(Submarinesprite1(600 * counter)), Submarine(counter).Position, Submarine(counter).Depth + 40, 254)
   NEXT
   
END SUB

FUNCTION DSPVersion!
' Gets the DSP version.
WriteDSP &HE1
TEMP% = ReadDSP%
Temp2% = ReadDSP%
DSPVersion! = VAL(STR$(TEMP%) + "." + STR$(Temp2%))
END FUNCTION

SUB Endtext
CLS
COLOR 14, 4
PRINT "Ŀ"
PRINT "                       THANKS FOR PLAYING SUBMARINES!!                        "
PRINT "                                                                              "
PRINT "                                                                              "
PRINT "                                                                              "
PRINT "                                                                              "
PRINT "                                                                              "
PRINT "                                                                              "
PRINT "                                                                              "
PRINT "                                                                              "
PRINT "                                                                              "
PRINT "                                                                              "
PRINT "                                                                              "
PRINT "                                                                              "
PRINT "                                                                              "
PRINT "                                                                              "
PRINT "                                                                              "
PRINT ""

COLOR 15, 4
LOCATE 4, 3: PRINT "This is my first " + CHR$(34) + "serious" + CHR$(34) + " game written in Qbasic. It was really fun,"
LOCATE 5, 3: PRINT "But Quickbasic isn't the best language, and i can use only 640k of memory to "
LOCATE 6, 3: PRINT "put my data + program in."
LOCATE 7, 3: PRINT "The next game i'll make is a side-scrolling adventure or platform game using"
LOCATE 8, 3: PRINT "the DirectQB library from Angelo Mottola."
LOCATE 10, 3: PRINT "You can contact me by email at dan_boon@dds.nl or by ICQ at 19396774."
COLOR 11, 2
LOCATE 12, 5: PRINT "This game is 100% freeware. Please copy it and give it to your friends  "
LOCATE 13, 5: PRINT "if you like to get the code, just send email.                           "
COLOR 13, 4
LOCATE 15, 3: PRINT "Sprite Routines developed by Andrew L. Ayers"
LOCATE 16, 3: PRINT "Midi routines by Jesse Dorland (jessedorland@hotmail.com)"
LOCATE 17, 3: PRINT "DMA waveplayer by Mike Huff"
COLOR 7, 0
PRINT
END SUB

FUNCTION getKey
'
' Returns the value of a pressed key
'

  dummy$ = ""
  dummy$ = INKEY$
  IF dummy$ = "" THEN EXIT FUNCTION

  getKey = CVI(dummy$ + CHR$(0))      ' Changes string

END FUNCTION

SUB Init
'
' Initializes the games
'

' Loading sprites
BlastLoad ScreenBuffer(), SpriteFile

'Loading Ship animation
FOR I = 0 TO 3

   CALL BlastGet(VARSEG(ScreenBuffer(0)), VARPTR(ScreenBuffer(0)), VARSEG(Shipsprite(0)), VARPTR(Shipsprite((I + 1) * 560)), I * 40, 0, I * 40 + 39, 14)
NEXT

'Loading the "smash-bomb" scene
FOR I = 0 TO 3

   CALL BlastGet(VARSEG(ScreenBuffer(0)), VARPTR(ScreenBuffer(0)), VARSEG(Shipsprite(0)), VARPTR(Shipsprite((I + 5) * 560)), I * 40, 15, I * 40 + 39, 29)
NEXT

' Loading the bomb image
CALL BlastGet(VARSEG(ScreenBuffer(0)), VARPTR(ScreenBuffer(0)), VARSEG(BombSprite1(0)), VARPTR(BombSprite1(15)), 160, 0, 165, 3)

' Loading the Submarine animation
FOR I = 0 TO 3

   CALL BlastGet(VARSEG(ScreenBuffer(0)), VARPTR(ScreenBuffer(0)), VARSEG(Submarinesprite(0)), VARPTR(Submarinesprite((I + 1) * 480)), I * 25 + 165, 0, I * 25 + 189, 20)
NEXT

' Loading the Submarine reverse animation
FOR I = 0 TO 3

   CALL BlastGet(VARSEG(ScreenBuffer(0)), VARPTR(ScreenBuffer(0)), VARSEG(Submarinesprite2(0)), VARPTR(Submarinesprite2((I + 1) * 480)), I * 25 + 165, 21, I * 25 + 189, 40)
NEXT

' Loading the Explosion animation
FOR I = 0 TO 3

   CALL BlastGet(VARSEG(ScreenBuffer(0)), VARPTR(ScreenBuffer(0)), VARSEG(Explosionsprite(0)), VARPTR(Explosionsprite((I + 1) * 480)), I * 25, 30, I * 25 + 24, 50)
NEXT

' Loading the granate picture
CALL BlastGet(VARSEG(ScreenBuffer(0)), VARPTR(ScreenBuffer(0)), VARSEG(GranateSprite(0)), VARPTR(GranateSprite(100)), 265, 0, 281, 6)

BlastCLS VARSEG(ScreenBuffer(0)), VARPTR(ScreenBuffer(0)), 0

RANDOMIZE (TIMER)    'Lets make the computer a little "random".... ;-)
SCREEN 13            'Set the monitor in the selected screenmode (13h)

Palette.Load Palettefile ' Loads the palette

' Set the SBmidi interrupt at 80 hexidecimal
MIDI.INTERRUPT = &H80

' Lets load the midi files into the memory

MIDIload "song1.mid", VARSEG(MIDIfile1(0)), VARPTR(MIDIfile1(0))
MIDIload "song2.mid", VARSEG(MIDIfile2(0)), VARPTR(MIDIfile2(0))

OPEN "Sound1.wav" FOR BINARY AS #1
OPEN "Sound4.wav" FOR BINARY AS #2
OPEN "Sound2.wav" FOR BINARY AS #3
OPEN "Sound3.wav" FOR BINARY AS #4
OPEN "Sound5.wav" FOR BINARY AS #5

GET #1, 44, SBsound(1)
GET #2, 44, SBsound1(1)
GET #3, 44, SBsound2(1)
GET #4, 44, SBsound3(1)

CLOSE       ' Close all opened files

Errorcode = 1
OPEN "submarin.cfg" FOR INPUT AS #1
INPUT #1, dummy$
Errorcode = 0
IF dummy$ <> "sbmidi" THEN soundon = False

game.maxBombs = 5             ' These variables are needed for calculating
game.maxSubmarines = 5        ' the space for the submarines , bombs etc.
game.Releasetime = 1
game.SpeedBombs = 1
game.SpeedShip = 1

END SUB

FUNCTION inside (insideX, insideY, insideX1, insideY1, x, y)
'
' Checks if a pixel is inside a box. Returns -1 if true, 0 if false
'
   inside = true
   
   IF x < insideX OR x > insideX1 THEN inside = False
   IF y < insideY OR y > insideY1 THEN inside = False

END FUNCTION

SUB MasterVolume (Right%, Left%, Getvol%)
OUT DMA.Baseport% + 4, &H22

IF Getvol% THEN
   Left% = INP(DMA.Baseport% + 5) \ 16
   Right% = INP(DMA.Baseport% + 5) AND &HF
   EXIT SUB
ELSE
   OUT DMA.Baseport% + 5, (Right% + Left% * 16) AND &HFF
END IF
END SUB

SUB Menu
'
' Shows the game menu at the begin of the game
'
BlastCLS VARSEG(ScreenBuffer(0)), VARPTR(ScreenBuffer(0)), 0

BlastLoad ScreenBuffer(), TitlePicture
DrawBOX VARSEG(ScreenBuffer(0)), VARPTR(ScreenBuffer(0)), 40, 60, 280, 180

BLASTprint VARSEG(ScreenBuffer(0)), VARPTR(ScreenBuffer(0)), 112, 88, "Start new game", 15
BLASTprint VARSEG(ScreenBuffer(0)), VARPTR(ScreenBuffer(0)), 112, 112, "Game setup", 15
BLASTprint VARSEG(ScreenBuffer(0)), VARPTR(ScreenBuffer(0)), 112, 136, "Exit", 15
BLASTprint VARSEG(ScreenBuffer(0)), VARPTR(ScreenBuffer(0)), 64, 168, "(C) by Daniel Boon, 1998", 15

' Start a background music
MIDIplay VARSEG(MIDIfile1(0)), VARPTR(MIDIfile1(0))
DO

   Delay .1       ' Delays the machine 0.1 seconds

   ' ** DRAWING SUBMARINES **

   frame = frame + 1: IF frame = 5 THEN frame = 1   'Change the frame

   ' make "backup" from place
   CALL BlastGet(VARSEG(ScreenBuffer(0)), VARPTR(ScreenBuffer(0)), VARSEG(Submarinesprite1(0)), VARPTR(Submarinesprite1(600)), 20, 30, 44, 50)
   CALL BlastGet(VARSEG(ScreenBuffer(0)), VARPTR(ScreenBuffer(0)), VARSEG(Submarinesprite1(0)), VARPTR(Submarinesprite1(1200)), 265, 30, 289, 50)

   ' Put sprite on buffer
   CALL BlastPUT(VARSEG(ScreenBuffer(0)), VARPTR(ScreenBuffer(0)), VARSEG(Submarinesprite(0)), VARPTR(Submarinesprite(480 * frame)), 20, 30, 255)
   CALL BlastPUT(VARSEG(ScreenBuffer(0)), VARPTR(ScreenBuffer(0)), VARSEG(Submarinesprite2(0)), VARPTR(Submarinesprite2(480 * frame)), 265, 30, 255)

   ' Put granate on screen
   CALL BlastGet(VARSEG(ScreenBuffer(0)), VARPTR(ScreenBuffer(0)), VARSEG(GranateSprite(0)), VARPTR(GranateSprite(200)), 90, 88 + (Menuchoice * 24), 116, 94 + (Menuchoice * 24))
   CALL BlastPUT(VARSEG(ScreenBuffer(0)), VARPTR(ScreenBuffer(0)), VARSEG(GranateSprite(0)), VARPTR(GranateSprite(100)), 90, 88 + (Menuchoice * 24), 255)
  
   ' Put Buffer on screen
   CALL BlastCopy(VARSEG(ScreenBuffer(0)), VARPTR(ScreenBuffer(0)), &HA000, 0)

   ' Put "backup" on the sprite
   CALL BlastPUT(VARSEG(ScreenBuffer(0)), VARPTR(ScreenBuffer(0)), VARSEG(Submarinesprite1(0)), VARPTR(Submarinesprite1(600)), 20, 30, 255)
   CALL BlastPUT(VARSEG(ScreenBuffer(0)), VARPTR(ScreenBuffer(0)), VARSEG(Submarinesprite1(0)), VARPTR(Submarinesprite1(1200)), 265, 30, 255)
   CALL BlastPUT(VARSEG(ScreenBuffer(0)), VARPTR(ScreenBuffer(0)), VARSEG(GranateSprite(0)), VARPTR(GranateSprite(200)), 90, 88 + (Menuchoice * 24), 255)
  
   SELECT CASE getKey
      CASE ArrowUp
         Menuchoice = Menuchoice + 1: IF Menuchoice > 2 THEN Menuchoice = 0
         Playsound 1
      CASE ArrowDown
         Menuchoice = Menuchoice - 1: IF Menuchoice < 0 THEN Menuchoice = 2
         Playsound 1
      CASE Arrowleft
         IF witchMenu = 1 THEN

            SELECT CASE Menuchoice
               CASE 0
                  game.maxBombs = game.maxBombs - 1
                  IF game.maxBombs = 1 THEN game.maxBombs = 1
               CASE 1
                  game.maxSubmarines = game.maxSubmarines - 1
                  IF game.maxSubmarines = 0 THEN game.maxSubmarines = 1
            END SELECT
            Playsound 1
            DrawBOX VARSEG(ScreenBuffer(0)), VARPTR(ScreenBuffer(0)), 40, 60, 280, 180

            BLASTprint VARSEG(ScreenBuffer(0)), VARPTR(ScreenBuffer(0)), 112, 88, "Max bombs " + STR$(game.maxBombs), 15
            BLASTprint VARSEG(ScreenBuffer(0)), VARPTR(ScreenBuffer(0)), 112, 112, "Submarines" + STR$(game.maxSubmarines), 15
            BLASTprint VARSEG(ScreenBuffer(0)), VARPTR(ScreenBuffer(0)), 112, 136, "Exit", 15
            BLASTprint VARSEG(ScreenBuffer(0)), VARPTR(ScreenBuffer(0)), 64, 168, "(C) by Daniel Boon, 1998", 15
         END IF
      CASE Arrowright
         IF witchMenu = 1 THEN

            SELECT CASE Menuchoice
               CASE 0
                  game.maxBombs = game.maxBombs + 1
                  IF game.maxBombs = 11 THEN game.maxBombs = 10
               CASE 1
                  game.maxSubmarines = game.maxSubmarines + 1
                  IF game.maxSubmarines = 11 THEN game.maxSubmarines = 10
            END SELECT
            Playsound 1
            DrawBOX VARSEG(ScreenBuffer(0)), VARPTR(ScreenBuffer(0)), 40, 60, 280, 180

            BLASTprint VARSEG(ScreenBuffer(0)), VARPTR(ScreenBuffer(0)), 112, 88, "Max bombs " + STR$(game.maxBombs), 15
            BLASTprint VARSEG(ScreenBuffer(0)), VARPTR(ScreenBuffer(0)), 112, 112, "Submarines" + STR$(game.maxSubmarines), 15
            BLASTprint VARSEG(ScreenBuffer(0)), VARPTR(ScreenBuffer(0)), 112, 136, "Exit", 15
            BLASTprint VARSEG(ScreenBuffer(0)), VARPTR(ScreenBuffer(0)), 64, 168, "(C) by Daniel Boon, 1998", 15
         END IF

      CASE Enter
               
         SELECT CASE Menuchoice
            CASE 0
               IF witchMenu = 0 THEN EXIT SUB
            CASE 1
               IF witchMenu = 0 THEN
                  Menuchoice = 0
                  DrawBOX VARSEG(ScreenBuffer(0)), VARPTR(ScreenBuffer(0)), 40, 60, 280, 180

                  BLASTprint VARSEG(ScreenBuffer(0)), VARPTR(ScreenBuffer(0)), 112, 88, "Max bombs " + STR$(game.maxBombs), 15
                  BLASTprint VARSEG(ScreenBuffer(0)), VARPTR(ScreenBuffer(0)), 112, 112, "Submarines" + STR$(game.maxSubmarines), 15
                  BLASTprint VARSEG(ScreenBuffer(0)), VARPTR(ScreenBuffer(0)), 112, 136, "Exit", 15
                  BLASTprint VARSEG(ScreenBuffer(0)), VARPTR(ScreenBuffer(0)), 64, 168, "(C) by Daniel Boon, 1998", 15
                  witchMenu = 1
               END IF
            CASE 2
               IF witchMenu = 0 THEN

                  Midistop
                  SCREEN 0: WIDTH 80: Endtext: END
               ELSE
                  Menuchoice = 0
                  DrawBOX VARSEG(ScreenBuffer(0)), VARPTR(ScreenBuffer(0)), 40, 60, 280, 180

                  BLASTprint VARSEG(ScreenBuffer(0)), VARPTR(ScreenBuffer(0)), 112, 88, "Start new game", 15
                  BLASTprint VARSEG(ScreenBuffer(0)), VARPTR(ScreenBuffer(0)), 112, 112, "Game setup", 15
                  BLASTprint VARSEG(ScreenBuffer(0)), VARPTR(ScreenBuffer(0)), 112, 136, "Exit", 15
                  BLASTprint VARSEG(ScreenBuffer(0)), VARPTR(ScreenBuffer(0)), 64, 168, "(C) by Daniel Boon, 1998", 15
                  witchMenu = 0
               END IF
      END SELECT
   END SELECT
LOOP

END SUB

'BytesRequired - Returns the amount of memory needed to store a file.
FUNCTION MIDIBytes& (Filename$)
'Open the file.
FF% = FREEFILE
OPEN Filename$ FOR BINARY AS #FF%
'Store the length of the file.
FileLen& = LOF(FF%)
'Close the file.
CLOSE FF%
'If the length of the file is 0, assume it does not exist and delete it.
IF FileLen& = 0 THEN
    KILL Filename$
    MIDI.Errorcode = 1
    EXIT FUNCTION
END IF
'Return the length of the file as the number of bytes required.
MIDIBytes& = FileLen&
MIDI.Errorcode = 0
END FUNCTION

'MIDIload - loads a MIDI file into memory
SUB MIDIload (Filename$, MIDISegment%, MIDIOffset%) STATIC
IF MIDI.INTERRUPT < &H80 AND MIDI.SENSITIVE <> 0 THEN MIDI.Errorcode = 4: EXIT SUB
'See if an extension was supplied, and if not, add one.
IF INSTR(Filename$, ".") = 0 THEN Filename$ = Filename$ + ".MID"
'Open the file
FF% = FREEFILE
OPEN Filename$ FOR BINARY AS #FF%
FileLen& = LOF(FF%)
CLOSE #FF%
'If the file is empty, delete it and exit now.
IF FileLen& = 0 THEN KILL Filename$: MIDI.Errorcode = 1: EXIT SUB
'If the file is too large, exit now.
IF FileLen& > 65536 THEN MIDI.Errorcode = 2: EXIT SUB
'Make the filename an ASCIIZ string.
Filename$ = Filename$ + CHR$(0)
'Check if the assembly language code has already been loaded;
'if not, do it now.
IF ask$ = "" THEN
        asm$ = asm$ + CHR$(&H1E)
        asm$ = asm$ + CHR$(&H55)
        asm$ = asm$ + CHR$(&H89) + CHR$(&HE5)
        asm$ = asm$ + CHR$(&HB8) + CHR$(&H0) + CHR$(&H3D)
        asm$ = asm$ + CHR$(&H8B) + CHR$(&H5E) + CHR$(&HE)
        asm$ = asm$ + CHR$(&H8B) + CHR$(&H17)
        asm$ = asm$ + CHR$(&H8B) + CHR$(&H5E) + CHR$(&H10)
        asm$ = asm$ + CHR$(&H8E) + CHR$(&H1F)
        asm$ = asm$ + CHR$(&HCD) + CHR$(&H21)
        asm$ = asm$ + CHR$(&H89) + CHR$(&HC6)
        asm$ = asm$ + CHR$(&HB4) + CHR$(&H3F)
        asm$ = asm$ + CHR$(&H8B) + CHR$(&H5E) + CHR$(&H8)
        asm$ = asm$ + CHR$(&H8B) + CHR$(&HF)
        asm$ = asm$ + CHR$(&H8B) + CHR$(&H5E) + CHR$(&HA)
        asm$ = asm$ + CHR$(&H8B) + CHR$(&H17)
        asm$ = asm$ + CHR$(&H8B) + CHR$(&H5E) + CHR$(&HC)
        asm$ = asm$ + CHR$(&H8E) + CHR$(&H1F)
        asm$ = asm$ + CHR$(&H89) + CHR$(&HF3)
        asm$ = asm$ + CHR$(&HCD) + CHR$(&H21)
        asm$ = asm$ + CHR$(&HB4) + CHR$(&H3E)
        asm$ = asm$ + CHR$(&HCD) + CHR$(&H21)
        asm$ = asm$ + CHR$(&H5D)
        asm$ = asm$ + CHR$(&H1F)
        asm$ = asm$ + CHR$(&HCA) + CHR$(&HA) + CHR$(&H0)
END IF
'Call the assembly language routine.
DEF SEG = VARSEG(asm$)
CALL ABSOLUTE(VARSEG(Filename$), SADD(Filename$), MIDISegment%, MIDIOffset%, &HFFFF, SADD(asm$))
MIDI.Errorcode = 0
END SUB

'MIDIplay - Begins playing a MIDI file in the background.
SUB MIDIplay (MIDISegment%, MIDIOffset%) STATIC
IF MIDI.INTERRUPT < &H80 AND MIDI.SENSITIVE <> 0 THEN MIDI.Errorcode = 4: EXIT SUB
IF soundon = False THEN EXIT SUB
'Check to see if the MIDI playing code has previously been loaded.
'If not, load it now.
IF asm$ = "" THEN
        'Load the machine codes into a string.
        asm$ = asm$ + CHR$(&H55)
        asm$ = asm$ + CHR$(&H89) + CHR$(&HE5)
        asm$ = asm$ + CHR$(&H8B) + CHR$(&H5E) + CHR$(&H8)
        asm$ = asm$ + CHR$(&H8B) + CHR$(&H17)
        asm$ = asm$ + CHR$(&H8B) + CHR$(&H5E) + CHR$(&H6)
        asm$ = asm$ + CHR$(&H8B) + CHR$(&H7)
        asm$ = asm$ + CHR$(&HBB) + CHR$(&H4) + CHR$(&H0)
        asm$ = asm$ + CHR$(&HCD) + CHR$(&H80)
        asm$ = asm$ + CHR$(&HBB) + CHR$(&H5) + CHR$(&H0)
        asm$ = asm$ + CHR$(&HCD) + CHR$(&H80)
        asm$ = asm$ + CHR$(&H5D)
        asm$ = asm$ + CHR$(&HCA) + CHR$(&H4) + CHR$(&H0)
END IF
IF MIDI.SOUNDDISABLED = 0 THEN
    'Call the machine language routine to play the music.
    DEF SEG = VARSEG(asm$)
    Offset% = SADD(asm$)
    CALL ABSOLUTE(MIDISegment%, MIDIOffset%, Offset%)
    'Start the MIDI timer.
    MIDI.Playtime = TIMER
END IF
END SUB

'MIDIstop - Stops playing MIDI file
SUB Midistop STATIC
IF MIDI.INTERRUPT < &H80 AND MIDI.SENSITIVE <> 0 THEN MIDI.Errorcode = 4: EXIT SUB
'Stop the music!!
IF asm$ = "" THEN
    asm$ = asm$ + CHR$(&HBB) + CHR$(&H4) + CHR$(&H0)
    asm$ = asm$ + CHR$(&HCD) + CHR$(MIDI.INTERRUPT)
    asm$ = asm$ + CHR$(&HCB)
END IF
IF MIDI.Playtime THEN
    DEF SEG = VARSEG(asm$)
    Offset% = SADD(asm$)
    CALL ABSOLUTE(Offset%)
    MIDI.Errorcode = 0
ELSE
    MIDI.Errorcode = 3
END IF
'No MIDI file is playing, so reset the timer
'MIDI.PLAYTIME = 0
END SUB

SUB moveObjects
'
' Moves the objects and calculate their place on the screen
'

   ' ** MOVE BOMBS **

   FOR counter = 1 TO ActiveBombs 'move bombs

      IF Bomb(counter).Smashing = 0 THEN
         Bomb(counter).Depth = Bomb(counter).Depth + game.SpeedBombs
      ELSE
         IF Ship.Smash = 0 THEN Bomb(counter).Smashing = False
      END IF
      Bomb(counter).frame = Bomb(counter).frame + 1
      IF Bomb(counter).frame = 5 THEN Bomb(counter).frame = 1
   NEXT
   IF ActiveBombs > 0 THEN

      IF Bomb(1).Depth + 40 = ScreensizeY THEN 'bomb falloff the screen

         ActiveBombs = ActiveBombs - 1
       
         ' erase the first bomb from array
         FOR counter = 1 TO ActiveBombs

            Bomb(counter).Depth = Bomb(counter + 1).Depth
            Bomb(counter).Position = Bomb(counter + 1).Position
         NEXT
      END IF
   END IF

   ' ** MOVE SHIP **

   Ship.Position = Ship.Position - game.SpeedShip
   IF Ship.Position <= 0 THEN

      Ship.Position = ScreensizeX
   END IF
   Ship.frame = Ship.frame + 1
   IF Ship.frame = 5 THEN Ship.frame = 1

   '** MOVE SUBMARINES **

   FOR counter = 1 TO ActiveSubmarines
      IF counter > ActiveSubmarines THEN EXIT FOR

      IF Submarine(counter).Exploded > 0 THEN
         Submarine(counter).Exploded = Submarine(counter).Exploded - 1
         Submarine(counter).Depth = Submarine(counter).Depth - 1
         IF Submarine(counter).Exploded = 0 THEN
            ' erase Submarine
            
            FOR EraseSubmarineCounter = counter + 1 TO ActiveSubmarines
               SWAP Submarine(EraseSubmarineCounter), Submarine(EraseSubmarineCounter - 1)
            NEXT

            ActiveSubmarines = ActiveSubmarines - 1
         END IF
      END IF
      Submarine(counter).Position = Submarine(counter).Position + Submarine(counter).Speed

      IF Submarine(counter).Position > ScreensizeX - 10 AND Submarine(counter).Speed > 0 THEN 'end of screen

         Submarine(counter).Position = 0
      END IF
      IF Submarine(counter).Position < 1 AND Submarine(counter).Speed < 0 THEN

         Submarine(counter).Position = ScreensizeX - 10
      END IF
     
      FOR BombCounter = 1 TO ActiveBombs ' check if a subamarine is hit

         IF BombCounter > ActiveBombs THEN EXIT FOR

         IF inside(Submarine(counter).Position, Submarine(counter).Depth, Submarine(counter).Position + 25, Submarine(counter).Depth + 20, Bomb(BombCounter).Position + 2, Bomb(BombCounter).Depth + 2) THEN

            'Erase bomb
            FOR EraseBombCounter = BombCounter + 1 TO ActiveBombs
                             
               SWAP Bomb(EraseBombCounter), Bomb(EraseBombCounter - 1)
            NEXT
            ActiveBombs = ActiveBombs - 1

            Submarine(counter).Exploded = 3
            Submarine(counter).frame = 1
            Playsound 3
         END IF
      NEXT
      Submarine(counter).frame = Submarine(counter).frame + 1
      IF Submarine(counter).frame = 5 THEN Submarine(counter).frame = 1
   NEXT
END SUB

SUB Palette.Load (Filename AS STRING)
'
' Loads a palette and put it to the screen
'

OPEN Filename FOR BINARY AS #1

DIM Buf AS STRING * 1
FOR I = 0 TO 255
   GET #1, , Buf: R = ASC(Buf)
   GET #1, , Buf: G = ASC(Buf)
   GET #1, , Buf: b = ASC(Buf)
  
   Palette.set I, R, G, b
NEXT I
CLOSE #1

END SUB

SUB Palette.set (nColor, Red, Green, Blue)
'
' Sets the red, green and blue (0/63) for color nColor (0-255)
'

   OUT &H3C6, &HFF
   OUT &H3C8, nColor
   OUT &H3C9, Red
   OUT &H3C9, Green
   OUT &H3C9, Blue
END SUB

SUB Playgame
'
' This sub is the main of the game; it calls the moveObjects and Drawobjects
' and it scans the keyboard for any pressed key.
'

' Place the new Submarines
FOR counter = 1 TO game.maxSubmarines

   Submarine(counter).Position = randomNumber(0, ScreensizeX - 20)
   Submarine(counter).Depth = randomNumber(0, ScreensizeY - 60)
   Submarine(counter).Speed = counter MOD 4 + 1
   Submarine(counter).Exploded = False
   IF Submarine(counter).Speed = 4 THEN Submarine(counter).Speed = -3
NEXT

ActiveSubmarines = game.maxSubmarines
ActiveBombs = 0
Ship.Position = 0

Midistop    ' Stop playing the current midi file

' Load background picture into screen buffer
BlastLoad ScreenBuffer(), LakePictureFile

DrawBOX VARSEG(ScreenBuffer(0)), VARPTR(ScreenBuffer(0)), 105, 90, 210, 117
BLASTprint VARSEG(ScreenBuffer(0)), VARPTR(ScreenBuffer(0)), 115, 100, "Get ready !", 15

'Put Buffer on screen
CALL BlastCopy(VARSEG(ScreenBuffer(0)), VARPTR(ScreenBuffer(0)), &HA000, 0)

Delay 1

' Load background picture into screen buffer
BlastLoad ScreenBuffer(), LakePictureFile


MIDIplay VARSEG(MIDIfile2(0)), VARPTR(MIDIfile2(0))

game.Time = TIMER

DO

   Delay .1 ' delay 0.1 seconds
   
   moveObjects
   drawObjects

   SELECT CASE getKey      ' Scans the keyboard for a pressed key
  
   CASE spacebar
      IF ActiveBombs < game.maxBombs THEN ' Drop a bomb

         IF keyPresswait + game.Releasetime <= TIMER OR keyPresswait = 0 THEN
                                   
            ActiveBombs = ActiveBombs + 1 ' create a new bomb
            Bomb(ActiveBombs).Position = Ship.Position + 8
            Bomb(ActiveBombs).Depth = 0
            Bomb(ActiveBombs).Smashing = true
            keyPresswait = TIMER
            Ship.Smash = 3
            Ship.frame = 1
            Playsound 4
         END IF
      END IF
   CASE 27
      DrawBOX VARSEG(ScreenBuffer(0)), VARPTR(ScreenBuffer(0)), 105, 90, 220, 117
      BLASTprint VARSEG(ScreenBuffer(0)), VARPTR(ScreenBuffer(0)), 115, 100, "Game aborted", 15

      'Put Buffer on screen
      CALL BlastCopy(VARSEG(ScreenBuffer(0)), VARPTR(ScreenBuffer(0)), &HA000, 0)

      Delay 2
      EXIT SUB
   END SELECT
   IF ActiveSubmarines = 0 THEN     ' all the submarines are destroyed
     
      DrawBOX VARSEG(ScreenBuffer(0)), VARPTR(ScreenBuffer(0)), 105, 90, 210, 117
      BLASTprint VARSEG(ScreenBuffer(0)), VARPTR(ScreenBuffer(0)), 115, 100, "You WON!!!!", 15

      'Put Buffer on screen
      CALL BlastCopy(VARSEG(ScreenBuffer(0)), VARPTR(ScreenBuffer(0)), &HA000, 0)
      Playsound 2
      Delay 2
      EXIT SUB
   END IF

   IF 90 - INT(TIMER - game.Time) < 1 THEN ' The time is up!
    
      DrawBOX VARSEG(ScreenBuffer(0)), VARPTR(ScreenBuffer(0)), 105, 90, 210, 117
      BLASTprint VARSEG(ScreenBuffer(0)), VARPTR(ScreenBuffer(0)), 115, 100, " Time up ! ", 15

      'Put Buffer on screen
      CALL BlastCopy(VARSEG(ScreenBuffer(0)), VARPTR(ScreenBuffer(0)), &HA000, 0)
      Delay 2
      EXIT SUB
   END IF

LOOP
END SUB

SUB Playsound (number)
IF soundon THEN
   SELECT CASE number
      CASE 1
         DMAplay VARSEG(SBsound(1)), VARPTR(SBsound(1)), 5408, 11000
      CASE 2
         DMAplay VARSEG(SBsound1(1)), VARPTR(SBsound1(1)), 15306, 11000
      CASE 3
         DMAplay VARSEG(SBsound2(1)), VARPTR(SBsound2(1)), 3698, 11000
      CASE 4
         DMAplay VARSEG(SBsound3(1)), VARPTR(SBsound3(1)), 9224, 11000
   END SELECT
END IF
END SUB

FUNCTION randomNumber (minValue, maxValue)
'
' Returns a random number between minValue and maxValue.
' Sorry, computers aren't that random.... but it gives a little "random idea".
'
   randomNumber = INT(RND * (maxValue - minValue)) + minValue
END FUNCTION

FUNCTION ReadDSP%
' Reads a byte from the DSP
DO
LOOP UNTIL INP(DMA.Baseport% + 14) AND &H80
ReadDSP% = INP(DMA.Baseport% + 10)
END FUNCTION

FUNCTION ResetDSP%
ct = 0: stat = 0: ready = &HAA
OUT DMA.Baseport% + &H6, 1
DO
        OUT DMA.Baseport% + &H6, 0
        stat = INP(DMA.Baseport% + &HE)
        stat = INP(DMA.Baseport% + &HA)
        IF stat = ready THEN EXIT DO
        ct = ct + 1
LOOP WHILE ct < 100 'wait about 100 ms
IF stat = ready THEN ResetDSP% = 1 ELSE ResetDSP% = 0
END FUNCTION

SUB SpeakerState (OnOff%)
' Turns speaker on or off.
IF OnOff% THEN WriteDSP &HD1 ELSE WriteDSP &HD3
END SUB

SUB WriteDSP (Byte%)
' Writes a byte to the DSP
a! = TIMER
DO
IF TIMER - a! > .5 THEN soundon = False: EXIT SUB
LOOP WHILE INP(DMA.Baseport% + 12) AND &H80
OUT DMA.Baseport% + 12, Byte%
END SUB

